/*
      *****************************************************************************
      *  Copyright (C) by Reinhard Heuberger                                 *
      *                                                                           *
      *  All rights reserved.                                                     *
      *                                                                           *
      *  Redistribution and use in source and binary forms, with or without       *
      *  modification, are permitted provided that the following conditions       *
      *  are met:                                                                 *
      *                                                                           *
      *  1. Redistributions of source code must retain the above copyright        *
      *     notice, this list of conditions and the following disclaimer.         *
      *  2. Redistributions in binary form must reproduce the above copyright     *
      *     notice, this list of conditions and the following disclaimer in the   *
      *     documentation and/or other materials provided with the distribution.  *
      *  3. Neither the name of the author nor the names of its contributors may  *
      *     be used to endorse or promote products derived from this software     *
      *     without specific prior written permission.                            *
      *                                                                           *
      *****************************************************************************
*/
module make_sysclock(
        Enable,                     // Enable
        Clk_65_6,                   // FPGA   Clock 65.6 MHz
        sync,
        //      
        System_clk);                // System clock  4.1 MHz
//
input  Enable, Clk_65_6, sync;
output System_clk;
//
reg [31:0] divider;                 // counter,= clock generator.
reg sync_p;
wire syncpuls;
//
//
always @ (posedge Clk_65_6)
begin
    sync_p <= sync;
end
assign syncpuls= !sync_p & sync;
//
//
always @ (posedge Clk_65_6)
begin
    if( Enable) begin
       if(syncpuls) begin
            divider <= 0;
        end else begin
           divider <= divider - 1;
        end
    end else begin
        divider <= 0;
    end
end
assign System_clk  =  divider[3];
//
endmodule
