/*
      *****************************************************************************
      *  Copyright (C)  by Reinhard Heuberger                                     *
      *                                                                           *
      *  All rights reserved.                                                     *
      *                                                                           *
      *  Redistribution and use in source and binary forms, with or without       *
      *  modification, are permitted provided that the following conditions       *
      *  are met:                                                                 *
      *                                                                           *
      *  1. Redistributions of source code must retain the above copyright        *
      *     notice, this list of conditions and the following disclaimer.         *
      *  2. Redistributions in binary form must reproduce the above copyright     *
      *     notice, this list of conditions and the following disclaimer in the   *
      *     documentation and/or other materials provided with the distribution.  *
      *  3. Neither the name of the author nor the names of its contributors may  *
      *     be used to endorse or promote products derived from this software     *
      *     without specific prior written permission.                            *
      *                                                                           *
      *****************************************************************************
*/
//
//
//  JUL-2018:  optimized for SoC/HPC .
//
//
module my_drive_select_SoC (
       enable,              // Enable
       clk_65_6,            // Clock
       Drive0_set,          ///
       Drive1_set,          ////
		 Drive2_set,          /////
		 Drive3_set,          //////-> Dip Switch
       Drive0_in,           //
       Drive1_in,           //
		 secpuls,             //
                            //
		 match0_H,
		 match1_H,
		 match2_H,
		 match3_H,
       match_H,             //
		 heartbeat);          //
//
input  enable, clk_65_6;
input  Drive0_set, Drive1_set, Drive2_set, Drive3_set;
input  Drive0_in, Drive1_in, secpuls;
output match0_H, match1_H, match2_H, match3_H;
output match_H, heartbeat;
//
reg match_H, match0_H, match1_H, match2_H, match3_H, secS;
reg [31:0] divider;
//
initial
begin
	match0_H <= 0;
   match1_H <= 0;
   match2_H <= 0;
   match3_H <= 0;
   match_H  <= 0;
end
//
always @ (posedge clk_65_6)
begin
  if(enable)begin
    if(Drive0_set && Drive1_in && Drive0_in)         // drive 0 
	   begin
	    match0_H <= 1;
		 match1_H <= 0;
		 match2_H <= 0;
		 match3_H <= 0;
		 match_H  <= 1;
		end
	 else if(Drive1_set && Drive1_in && !Drive0_in)   // drive 1
	   begin
	    match0_H <= 0;
		 match1_H <= 1;
		 match2_H <= 0;
		 match3_H <= 0;
		 match_H  <= 1;
		end
	 else if(Drive2_set && !Drive1_in && Drive0_in)    // drive 2
	   begin
	    match0_H <= 0;
		 match1_H <= 0;
		 match2_H <= 1;
		 match3_H <= 0;
		 match_H  <= 1;		
		end
	 else if(Drive3_set && !Drive1_in && !Drive0_in)   // drive 3
	   begin
	    match0_H <= 0;
		 match1_H <= 0;
		 match2_H <= 0;
		 match3_H <= 1;
		 match_H  <= 1;
		end
	 else 
	    match_H <= 0;
  end else begin
    match_H <= 0;
  end
end
//
//
always @ (posedge clk_65_6)
begin
 secS <= secpuls;
end
//
always @ (posedge clk_65_6)
begin
  if ( secpuls  & !secS) begin
    divider <= divider +1 ;
  end else begin
   divider <= divider ;
  end
end
assign heartbeat = divider[8];
//
endmodule
