/*
      *****************************************************************************
      *  Copyright (C)  by Reinhard Heuberger                                     *
      *                                                                           *
      *  All rights reserved.                                                     *
      *                                                                           *
      *  Redistribution and use in source and binary forms, with or without       *
      *  modification, are permitted provided that the following conditions       *
      *  are met:                                                                 *
      *                                                                           *
      *  1. Redistributions of source code must retain the above copyright        *
      *     notice, this list of conditions and the following disclaimer.         *
      *  2. Redistributions in binary form must reproduce the above copyright     *
      *     notice, this list of conditions and the following disclaimer in the   *
      *     documentation and/or other materials provided with the distribution.  *
      *  3. Neither the name of the author nor the names of its contributors may  *
      *     be used to endorse or promote products derived from this software     *
      *     without specific prior written permission.                            *
      *                                                                           *
      *****************************************************************************
*/  
//
module  test_mux (
        clk_65_6,
        emulator,
		  clone,
		  write,
        emu_mode,           // Emulator/clone mode
        write_mode,         // Clone or Write mode:
		  //
		  TEST);
// 
input [7:0] emulator;
input [7:0] clone;
input [7:0] write;
input clk_65_6, emu_mode, write_mode;
output [7:0] TEST;
//
reg [7:0] TEST; 
//
always @ (negedge clk_65_6)
begin
    if(!emu_mode) begin 	                                          // emulator mode
		TEST <= emulator;
    end else if ( emu_mode & !write_mode) begin
	   TEST <= clone;
	 end else if ( emu_mode & write_mode) begin
	   TEST <= write;
	 end
end
//
endmodule
